/*
                 Copyright(c) 2005 Toufik Sarni

This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA*/


#include <kernel.h>

int _fptr _write(unsigned char lect,unsigned short cyl,unsigned short tete,
           unsigned short sect,unsigned short nbr,char  far *p)
   {
     asm{
         push bx
         push cx
         push dx

         mov ah,03   // fonction d'criture
         mov al,byte ptr nbr
         mov ch,byte ptr cyl
         mov cl,byte ptr sect
         mov dh,byte ptr tete
         mov dl,byte ptr lect    // lecteur
         les  bx,dword ptr p
         int 0x13
         jnc suite0

         pop dx
         pop cx
         pop bx

         xor ax,ax     // il y a erreur
         jmp err0
    suite0:
         pop dx
         pop cx
         pop bx
         mov ax,1

   err0:
         }
  }
int _fptr _read(unsigned char lect,unsigned short cyl,unsigned short tete,
           unsigned short sect,unsigned short nbr,char  far *p)
   {
     asm{
         push bx
         push cx
         push dx

         mov ah,02   // fonction de lcture
         mov al,byte ptr nbr
         mov ch,byte ptr cyl
         mov cl,byte ptr sect
         mov dh,byte ptr tete
         mov dl,byte ptr lect    // lecteur
         les  bx,dword ptr p
         int 0x13
         jnc suite1

         pop dx
         pop cx
         pop bx

         xor ax,ax     // il y a erreur
         jmp err1
    suite1:
         pop dx
         pop cx
         pop bx
         mov ax,1

   err1:
         }
  }
