/*
                 Copyright(c) 2005 Toufik Sarni

This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA*/

#include <stdio.h>
#include <io.h>
#include <fcntl.h>

int main(int argc, char* argv[])
{
printf("CAT version 1.0 par toufik SARNI.\n\n");
if (argc != 3)
       {
        printf("Usage: CAT [Fichier1] [Fichier2]\n");
        return 1;
       } 
int handle2 = open(argv[2], O_RDONLY);
   unsigned long taille2= (unsigned long)filelength(handle2);       
 
close(handle2);

int handle1 = open(argv[1], O_RDONLY);
   unsigned long taille1= (unsigned long)filelength(handle1);       
close(handle1);     

   FILE *fich1, *fich2;

   if ((fich1 = fopen(argv[1], "a+b"))
       == NULL)
   {
      printf("Erreur d'ouverture du fichier: %s.\n",argv[1]);
      return 1;
   }

   if ((fich2 = fopen(argv[2], "rb"))
       == NULL)
   {
      printf("Erreur d'ouverture du fichier: %s.\n",argv[2]);
      return 1;
   }


static unsigned long temp=0,x1=0,x2=0;
static char chr[512];

printf(" %s : %d octets\n",argv[1],taille1);
printf("\n %s : %d octets\n",argv[2],taille2); 

while ((temp+512)<=taille2){

              fread(&chr[0],512,1,fich2);
              fwrite(&chr[0],512,1,fich1);
              temp+=512;
              //fgetpos(fich1,(long *)&x1);
              x1+=512;
              fsetpos(fich1,(const long *)&x1);
              //fgetpos(fich2,(long *)&x2);
              x2+=512;
              fsetpos(fich2,(const long *)&x2);
                      }
   unsigned int tempos=taille2-temp;

if (tempos>0)
           { 
        while(temp<taille2){
           fread(&chr[0],tempos,1,fich2);
           fwrite(&chr[0],tempos,1,fich1);
            temp+=tempos;
              //fgetpos(fich1,(long *)&x1);
              x1+=tempos;
              fsetpos(fich1,(const long *)&x1);
              //fgetpos(fich2,(long *)&x2);
              x2+=tempos;
              fsetpos(fich2,(const long *)&x2);
                            }
          }

   fclose(fich2);
   fclose(fich1);

handle1 = open(argv[1], O_RDONLY);
  taille1= (unsigned long)filelength(handle1);       
 
close(handle1);     
   printf("\nla nouvelle taille de %s: %d octets.\n",argv[1],taille1);
  
return 0;
}
