/*
                 Copyright(c) 2005 Toufik Sarni

This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA*/

#include <kernel.h>

const char _fptr * vprint(char _fptr *fmt,char _fptr *prm);

#ifdef  __C32__
   char *buffer_print=(char *)0x16000;
   char *buffer_temp_print=(char *)0x17000;

#elif defined(__C16__)
   char _fptr *buffer_print=(char _fptr *)0x10001600;
   char _fptr *buffer_temp_print=(char _fptr *)0x10001700;
#endif

void print(char _fptr *frt,...)
 {
  char _fptr *argument=(char _fptr *)&frt;
  printk(vprint(frt, argument+4),couleur_base);
 }

const char _fptr * vprint(char _fptr*fmt,char _fptr *prm)
  {
   char _fptr *buffer=&buffer_print[0],_fptr *temp=fmt;
   char _fptr *tab=&buffer_temp_print[0];

   while (*fmt !=0)
    {
      if (*fmt=='%') {
                     fmt++;
                 switch(*fmt){
                 case 'd': *tab='d';tab++;break;
                 case 's': *tab='s';tab++;break;
                 case 'x': *tab='x';tab++;break;
                 case 'X': *tab='X';tab++;break;
                 case 'p': *tab='p';tab++;break;
                 case 'P': *tab='p';tab++;break;
                 case 'c': *tab='c';tab++;break;
                 case '%': *tab='%';tab++;break;
                             }
                fmt++;
                     }
     else fmt++;
    }

    fmt=temp;                          /* restauration du pointeur*/
    *tab=0;                            /* indiquer fin du tableau*/
    tab=&buffer_temp_print[0];         /* aller au debut du tableau*/

    unsigned long _fptr *parametre=(unsigned long _fptr*)prm;

    while (*fmt!=0)
    if (*fmt!='%') {*buffer=*fmt; buffer++;fmt++;}

    else {

    if (*tab!=0)
      { fmt+=2;           /*pour eviter d'inesrer (%d ou %s...) dans le buffer*/

      parametre=(unsigned long _fptr*)prm;        /*avoir un pointeur long sur le paramtre*/
      *buffer=0;                         /*pour indiquer le debut de strcat*/

      switch(*tab){

      case 'd':  strcat(buffer,decasc(*parametre));

            fin_buff:
             while(*buffer!=0)buffer++; /*aller  la fin du buffer*/
                break;

      case 's':
                strcat(buffer,(const char _fptr*)*parametre);
                goto fin_buff; /* <=> while(*buffer!=0)buffer++;break;*/

      case 'x': strcat(buffer,hexascinv((const char _fptr*)parametre,2));
                goto fin_buff;

      case 'X': strcat(buffer,hexascinv((const char _fptr*)parametre,4));
                goto fin_buff;

      case 'p': strcat(buffer,hexascinv((const char _fptr *)parametre,4));
                goto fin_buff;

      case 'c': *buffer=*prm; /*inserer le caractre en question dans le buffer*/
                buffer++;*buffer=0;break;

      case '%': *buffer='%';
                buffer++;*buffer=0;
                 }
      prm+=4;tab++;
      }
         }
      *buffer=0; /*fin de chaine*/

return &buffer_print[0];
  }
