/*
                 Copyright(c) 2005 Toufik Sarni

This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA*/


#include <kernel.h>

int _write(u8 lect,u16 cyl,u16 tete,u16 sect,u32 adr)
   {
     u16 *p=(u16 *)((reel_buffer)+512);
     __write(lect,cyl,tete,sect,adr);
     if (*p==0xAA55)
         return 1;
     return 0;
   }

int _read(u8 lect,u16 cyl,u16 tete,u16 sect)
   {
     u16 *p=(u16 *)((reel_buffer)+512);
     __read(lect,cyl,tete,sect);
     if (*p==0xAA55)
         return 1;
     return 0;
   }
