/*
                 Copyright(c) 2005 Toufik Sarni

This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA*/


#include <kernel.h>

#define ID_PRINTK 1
#define ID_PUTCHR 2
#define ID_WRITE  3
#define ID_READ   4

void id_printk(u16 couleur)
{
  u16 *ptr=(u16 *)adr_param_reel;
  *ptr=ID_PRINTK;    //ID de la fonction printk, (par convention)
  ptr++;
  *ptr=couleur;
}

void id_putchr(u16 chr,u16 couleur,u16 cpt)
 {
  u16 *ptr=(u16 *)adr_param_reel;
  *ptr=ID_PUTCHR;        
  ptr++;
  *ptr=cpt;
  ptr++;
  *ptr=couleur;
  ptr++;
  *ptr=chr;
  }
void id_write(u8 lect,u16 cyl,u16 tete,u16 sect)
 {
  u16 *ptr=(u16 *)adr_param_reel;
  *ptr=ID_WRITE;
  *(++ptr)=sect;
  *(++ptr)=tete;
  *(++ptr)=cyl;
  *(++ptr)=lect;
 }
void id_read(u8 lect,u16 cyl,u16 tete,u16 sect)
 {
  u16 *ptr=(u16 *)adr_param_reel;
  *ptr=ID_READ;
  *(++ptr)=sect;
  *(++ptr)=tete;
  *(++ptr)=cyl;
  *(++ptr)=lect;
 }

