/*
                 Copyright(c) 2005 Toufik Sarni

This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA*/



#include <kernel.h>
#include <proc.h>
#include <idt.h>
#include <kbd.h>

void call_int0(void){ printk("Dvision par zro\n",i_blanc);while(1);}
void call_int1(void){ printk("Mode trace\n",i_blanc);
    }
void call_int2(){ printk("halt! Interruption non masquable\n",i_blanc);
    }
void call_int3(){ printk("INT3: point d'arrt\n",i_blanc);
    }
void call_int4(){ printk("Dbordement: Overflow rencontr.\n",i_blanc);
    }
void call_int5(){ printk("Bound hors limite.\n",i_blanc);
    }
 void call_int6(){ printk("Instruction non valide\n",i_blanc);while(1);
    }
 void call_int7(){ printk("FPU: Coprocesseur mathmatique non disponible.\n",i_blanc);
    }
 void call_int8(){ printk("INT8: Double faute\n",i_blanc);
    }
 void call_int9(){ printk("Dbordement de segment FPU\n",i_blanc);
    }
 void call_intA(){ 
    unsigned long i,*ptr;
    asm {
    mov dword ptr i,esp}
    ptr=(unsigned long *)i;
    for (i=0;i<=10;i++,ptr++) print("[%X]: %X\n",ptr,*ptr);
    printk("TSS invalide\n",i_blanc);
    while(1);
    }
 void call_intB(){ printk("Segment non prsent\n",i_blanc);
    }
 void call_intC(){ printk("Faute de pile\n",i_blanc);
    }

 void call_intD(){
    u32 i,*ptr;
    asm { push eax
          mov eax,esp
          mov dword ptr i,eax
          pop eax
         }
    ptr=(u32 *)i;
    for (i=0;i<=14;i++,ptr++) print("[%X]: %X\n",ptr,*ptr);
   //printk("Erreur de protection gnrale\n",i_blanc);
   //print("eax: %X  ebx: %X  ecx: %X edx: %X\n",_eax,_ebx,_ecx,_edx);
  // print("esi: %X  edi: %X  ebp: %X esp: %X\n",_esi,_edi,_ebp,_esp);
   //print("cr3: %X  eflags: %X  tr:%x\n",_cr3,_eflags,_tr);
  // print("cs: %x    ds:%x      ss:%x\n",_cs,_ds,_ss);
   //debug();
    while(1);
    }

 void call_intE(){
    printk("Faute de page\n",i_blanc);
    unsigned long i,*ptr;
    asm {
    mov dword ptr i,esp}
    ptr=(unsigned long *)i;
    //for (i=0;i<=10;i++,ptr++) print("[%X]: %X\n",ptr,*ptr);
    //debug();
    //while(1);

    }
 void call_intF(){
    }
 void call_int10(){ printk("Erreur FPU\n",i_blanc);
    }
 void call_int11(){ printk("Erreur d'alignement",i_blanc);
    }
 void call_int50(){
                   #ifdef TEMPS_PARTAGE
                   schedule();
                   #endif
                  }

u8 id_aperiodique_clavier;
 void call_int51()
   {
    #ifdef TEMPS_REEL
    signaler_aperiodique(id_aperiodique_clavier);
    #endif

    #ifdef TEMPS_PARTAGE
    u8 i=0;
     
       while((inpb(0x64) & 0x01) == 0);
         i=inpb(0x60);
             i--;
             if (i<=85) 
                   print("%c",kbdmap[i*4]);
   #endif
   }



  void call_int52(){ printk("CTRL IT\n",i_blanc);
  debug();
  while(1);
  }

  void call_int53(){ printk("IRQ2: CTRL IT\n",i_blanc);
  //debug();
  while(1);
  }
  void call_int57(){
  print("IRQ7: \n");
  //debug();
  //while(1);
  }


DATE cpt_absolu;
extern u8 signal_aperiodique;
extern u32 top_aperiodique;

  void call_int60()
  {
    cpt_absolu++;        
    //print("get_abloute_time:%d\n",(u32)get_absolute_time());

    #ifdef TEMPS_REEL
    if (etat_IT)  //si sti_tr()
       schedule_tr();  //lance le scheduler temps rel, voir: schedule.cpp
    #endif

  }

