          unsigned char type_lect=0;
          unsigned char nbr_lecteur=0;
          unsigned char nbr_secteur=0;
          unsigned char nbr_tete=0;
          unsigned int  nbr_cylindre=0;

 asm{
     mov ah,08 /*demande parametre d'1 unit*/
     mov dl,00 /*unit de disquette*/
     int 0x13
    mov byte ptr type_lect,bl
    mov byte ptr nbr_lecteur,dl
    mov byte ptr nbr_tete,dh
    mov al,cl
    and al,0x3f //pour extraire les 6-bit  poids faible
    mov byte ptr nbr_secteur,al
    xchg cl,ch  //car les 2 bits du poids fort du cylindre sont dans cl
    mov bx,cx
    xor dx,dx
    mov dl,ch
    mov cl,6
    shr dx,cl
    mov bh,dl //dl contient aprs dcalage de 6-bit, les 2-bit p-fort du cylindre
    mov word ptr nbr_cylindre,bx

    }
  disquette.type=(unsigned char)type_lect;
  disquette.nbr_lecteur=(unsigned char)nbr_lecteur;
  disquette.nbr_secteur=(unsigned char)nbr_secteur;
  disquette.nbr_tete=(unsigned char)nbr_tete;
  disquette.nbr_cylindre=(unsigned int)nbr_cylindre;

 asm{
     mov ah,08 
     mov dl,0x80 /*unit disque dr*/
     int 0x13
    mov byte ptr nbr_lecteur,dl
    mov byte ptr nbr_tete,dh
    mov al,cl
    and al,0x3f //pour extraire les 6-bit  poids faible
    mov byte ptr nbr_secteur,al
    xchg cl,ch  //car les 2 bits du poids fort du cylindre sont dans cl
    mov bx,cx
    xor dx,dx
    mov dl,ch
    mov cl,6
    shr dx,cl
    mov bh,dl //dl contient aprs dcalage de 6-bit, les 2-bit p-fort du cylindre
    mov word ptr nbr_cylindre,bx

    }
  disque_dur.nbr_lecteur=(unsigned char)nbr_lecteur;
  disque_dur.nbr_secteur=(unsigned char)nbr_secteur;
  disque_dur.nbr_tete=(unsigned char)nbr_tete;
  disque_dur.nbr_cylindre=(unsigned int)nbr_cylindre;

/* nous allons  prsent, charger la partie 32-bit du noyau*/
  /*l'ID du lecteur de boot est  1000h:0000, mis par le programme boot au dmarrage */

unsigned char _fptr * id_boot=(char _fptr *)0x10000000;
unsigned char nbr_sect_charger=18; /*equivaut  9K (512*18)*/

  unsigned char boot_id=*id_boot;

if ((boot_id>=(unsigned char)0)&&(boot_id<=(unsigned char)10)){
       if (disquette.type==04)
              asm{
              clc
              mov ah,2
              mov al,byte ptr nbr_sect_charger
              mov cl,1  /*secteur 1*/
              mov ch,0  /*cylindre 0*/
              mov dh,1  /*tte 1*/
              mov dl,byte ptr boot_id
              mov bx,9000h
              mov es,bx
              xor bx,bx   //l'@ 9000h:0000 est temporaire, on faira plus loin, un transfert  l'@ 0x100000
              int 0x13
              jc _err
              clc
              mov ah,2
              mov al,byte ptr nbr_sect_charger
              mov cl,1  /*secteur 1*/
              mov ch,1  /*cylindre 1*/
              mov dh,0  /*tte 0*/
              mov dl,byte ptr boot_id
              mov bx,9000h
              mov es,bx
              mov bx,2400h   //l'@ 9000h:2400h
              int 0x13
              jc _err
              clc
              mov ah,2
              mov al,byte ptr nbr_sect_charger
              mov cl,1  /*secteur 1*/
              mov ch,1  /*cylindre 1*/
              mov dh,1  /*tte 1*/
              mov dl,byte ptr boot_id
              mov bx,9000h
              mov es,bx
              mov bx,4800h   //l'@ 9000h:4800h
              int 0x13
              jc _err
              clc
              mov ah,2
              mov al,byte ptr nbr_sect_charger
              mov cl,1  /*secteur 1*/
              mov ch,2  /*cylindre 1*/
              mov dh,0  /*tte 1*/
              mov dl,byte ptr boot_id
              mov bx,9000h
              mov es,bx
              mov bx,6C00h   //l'@ 9000h:6C00h
              int 0x13
              jc _err

             
              }

      else {printk("\nLecteur de disquette non pris en charge, systme arrt.\n",cli_i_rouge);debug();hlt();
            _err:
            printk("\nDisquette deffectueuse!\nChargement du noyau impossible.",i_rouge);hlt();}
                                    }
      goto continuer;
if ((boot_id>=(unsigned char)0x80)&&(boot_id<=(unsigned char)0x8A)){
                        
              asm{
              mov ah,2
              mov al,byte ptr nbr_sect_charger
              mov cl,19  /*secteur 19*/
              mov ch,0  /*cylindre 0*/
              mov dh,1  /*tte 0*/
              mov dl,byte ptr boot_id 
              mov bx,9000h
              mov es,bx
              xor bx,bx   //l'@ 9000h:0000 est temporaire, on faira plus loin, un transfert  l'@ 0x100000
              int 0x13}
                                         }

 continuer:
