/*
                 Copyright(c) 2005 Toufik Sarni

This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA*/

#include <kernel.h>

const char _fptr *strcpy(char _fptr *dest,char _fptr *src)
{
  int i=0,j=0;
  char _fptr *fdest=dest;
  char _fptr *fsrc=src;

  while (*fsrc) { i++;fsrc++;}
  fsrc=src;
  for (;j<=i;j++,fdest++,fsrc++) *fdest=*fsrc; //la fin de chaine 0 est copie aussi.
  return dest;
}



char _fptr *strcat(char _fptr *dest,const char _fptr *src)
{
  char _fptr *fdest=dest;
  while (*fdest) fdest++; //aller  la fin de la chaine
  while(*src)
    {
    *fdest=*src;
    fdest++;
    src++;
    }
*fdest=0; //indiquer la fin de chaine
return dest;
}
